/* tests.c */

/*********************************************************************************
License for TCB - Bhutan Calendar software for "grub rtsis"

Copyright (c) 2009-2011 Edward Henning

Permission is hereby granted, free of charge, to any person  obtaining a copy of
this software and associated documentation files (the "Software"), to deal in the
Software without restriction, including without limitation the rights to use, 
copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
Software, and to permit persons to whom the Software is furnished to do so, subject 
to the following conditions: 

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <conio.h>
#include "tc.h"
#include "tc.ext"

// Local to this file only:

long int start_year, end_year;

void srch_cyc ( void )  // Main search and analysis routine. Reuses existing code.
  {
    int more, n, newmth, i;;
    char chr;
    restart: cls ();
//  Changed for Win32 console app:
//  as workaround to Vista and Windows 7 incompatibility, 6/1/2011    
//  pos (0,0);

    printf ( "%s\n", e_str[epch] );
    printf ("Enter the starting lunar date, month and year: ");
    scanf ("%ld %ld %ld", &tt, &tm, &ty);

    start_year = ty;
    
    printf ("\n");
    n = 0;
    more = 1;
    newmth = 1;
    while (more)
      {
        if ( newmth )
          {
            if ( !zeromthfg )   // We need to use the same data, twice.
              zla_dag (ty, tm);
            adj_zla ();
            cur_mth = zladag[0];
            gza_dru (cur_mth);
            nyi_dru (cur_mth);
            rilchaf ( cur_mth ); // MOVED, from gza_dag, NEW, 11/9/94
          }

        printf ("\nThe ZLA-DAG is: %ld;%ld, ", zladag[0], zladag[1]);
        printf ("Month = %ld, ", tm );
        printf ("Year = %ld\n", ty );

        printf ("DATE is: %ld / %ld / %ld,  ", tt, tm, ty);
        printf ( "Corrected Month = %ld\n", adj_mth );
        tse_dru (tt);
        nyi_lon (tt);

        printf ("The gza-dru is: ");
        prn_lst ( gzadru );
        printf ("The nyi-dru is: ");
        prn_lst ( nyidru );

        add_gen (tsebar, gzadru, tsedru, 7L, 707L);
        add_gen (nyibar, nyidru, nyilon, 27L, sun_f );
        nyibarl = exp_lst ( nyibar, sun_f ); // These are for time of day
        tsebarl = exp_lst ( tsebar, 707L ); // and western comparisons
        printf ( "ril cha = %ld, %ld\n", rilcha[0], rilcha[1] );
        printf ("The gza-bar is: ");
        prn_lst ( tsebar );
        printf ("The nyi-bar is: ");
        prn_lst ( nyibar );
        nyi_dag (nyibar);  // Must be done before gza_dag
        gza_dag (tsebar);
        do_rahu ( cur_mth, tt );
        printf ("The gza-dag is: ");
        prn_lst ( gzadag );
        printf ("The nyi-dag is: ");
        prn_lstd ( nyidag, sun_f, 1L );
       printf ("The nyi-dag is: ");
        prn_lstd ( nyidag, sun_f, 1L );
        
        clrlst (mondag);
        clrlst (monsar);
        mondag[1] = 54L; // separation in one lunar day.
        mul_gen ( mondag, mondag, tt, 27L, sun_f );
        add_gen ( mondag, nyidag, mondag, 27L, sun_f ); // KTC 42
        for ( i = 0; i < 6; ++i )
          monsar[i] = gzadag[i];
        monsar[0] = 0L;
        monsar[5] = ( monsar[5] * sun_f ) / gza_f;
        sub_gen ( monsar, mondag, monsar, 27L, sun_f); // KTC 43

        spi_zagf ();
        do_plans ( spizag );

        printf ( "SPYI ZHAG = %ld. ", spizag );
        printf ( "Julian day = %ld. ", juldat );
        printf ( "Western date = %s, %ld/%ld/%ld\n",
                  dayoweek[ (int) doweek ], wd, wm, wy);

// Write the required test criteria here:

        if ( ( adj_mth == 11L || adj_mth == -11L ) &&
                gzadag[0] == 6L && 
              ( mondag[0] == 7L || monsar == 7L )
           )  
           
        chr = getch ();
        if ( chr == 'E' || chr == 'e' )
          more = 0;
//        chr = 'm'; // Repeat every month 
//      chr = 'y'; // Repeat every year
        chr = 't'; // Repeat every lunar day

        end_year = 1505L;

        if ( wy == end_year )
          more = 0;

        if ( chr == 'N' || chr == 'n' )
          goto restart;
 
        else if ( chr == 'T' || chr == 't' )
          {
            ++tt;
            newmth = 0;
            if ( tt == 31L )
              {
                newmth = 1;
                tt = 1;
                if ( !zeromthfg )
                  ++tm;
                if ( tm > 12 )
                  {
                    ++ty;
                    tm = 1;
                  }
              }
          }
        else if ( chr == 'M' || chr == 'm' )
          {
            newmth = 1;
            if ( ! zeromthfg )
              ++tm;
            if ( tm > 12 )
              {
                ++ty;
                tm = 1;
               }
          }
        else if ( chr == 'Y' || chr == 'y' )
          {
//          ++ty; // Watch this!
            ty = ty + 5L;
            newmth = 1;
            zeromthfg = 0;
          }
      }
    fclose ( fptgt );
  } // END - srch_cyc ()

